#![no_std]
#![no_main]

#[macro_use]
extern crate klee;
extern crate panic_abort;

extern crate volatile_register;
use volatile_register::RW;

#[no_mangle]
fn main() {
    let rw: RW<u32> = unsafe { core::mem::uninitialized() };

    unsafe {
        rw.modify(|r| {
            if r == 0 {
                panic!(); // rust compiler calls panic abort
            }
            0
        });
    }

    if rw.read() == 0 {
        klee::abort(); // we directly call the intrinsic abort
    }
}
